"""
###################################################
===================================================
Smart Pray4D - a 'real time' Python raytracer 
===================================================
Ported and optimized for Cinema 4D by:
Jan-C. Frischmuth (http://www.smart-page.net/blog)
---------------------------------------------------
Original ECMA versions by:
keim_at_Si (http://www.yomogi.sakura.ne.jp/~si/)
---------------------------------------------------
http://www.opensource.org/licenses/mit-license.php 
===================================================
Global config in :'/smartpray4dpackage/config.py'
Scene setup in   :'/smartpray4dpackage/scene.py'
===================================================
###################################################
"""

import c4d

import os, sys

folder = os.path.dirname(__file__)
if folder not in sys.path:
    sys.path.insert(0, folder)
    
from smartpray4dpackage.config import PLUGIN_ID
from smartpray4dpackage.mycommanddata import MyCommandData

#register plugin
if __name__ == "__main__":
     icon = c4d.bitmaps.BaseBitmap()
     icon.InitWith(os.path.join(os.path.dirname(__file__), "res", "smartpray4d.tif"))
     c4d.plugins.RegisterCommandPlugin(PLUGIN_ID, "Smart Pray4D", 0, icon, "A crazy Python benchmark", MyCommandData())