import c4d
from c4d import gui

from smartpray4dpackage.config import SIZE, FPSCAP
from smartpray4dpackage.myuserarea import MyUserArea
from smartpray4dpackage.renderer import Renderer
from smartpray4dpackage.scene import Scene
    

class MyDialog(gui.GeDialog):
    
    __userarea = None
    
    __renderer = None  
    __scene    = None
    
    def __init__(self): 
    
        self.__userarea = MyUserArea() 
        self.__scene    = Scene() 
        self.__renderer = Renderer(SIZE)
        
    
    #called on 'Open()'
    def CreateLayout(self):  

        self.SetTitle("Smart Pray4D Renderview")

        self.GroupBegin(c4d.BFH_LEFT | c4d.BFV_TOP, 0, 1)
        self.GroupBorderSpace(0, 0, 0, 0)

        self.AddUserArea(1001, c4d.BFH_SCALEFIT | c4d.BFV_SCALEFIT, 400, 183)
        self.AttachUserArea(self.__userarea, 1001, c4d.USERAREA_COREMESSAGE)

        self.GroupEnd()                  

        self.SetTimer(FPSCAP/10)  
        
        return True
              
              
    def Timer(self, bc):
        
        if self.IsOpen() and self.IsVisible():
            self.__renderer.Render(self.__scene, self.__userarea)