import c4d

import math

from smartpray4dpackage.config import SIZE
from smartpray4dpackage.material import Material
from smartpray4dpackage.sphere import Sphere


class Scene:

    ambient    = 0.1
    diffusion  = 0.7
    specular   = 0.6
    power      = 12
    
    camX       = 0
    camY       = 50
    camZ       = -500
    
    light      = c4d.Vector(100)
    ldir       = c4d.Vector()
    
    spheres    = []
    
    floorY     = 100;
    
    fcol       = [None]*1024
    smap       = [None]*512
    
    reff       = [0xffffff, 0x7f7f7f, 0x3f3f3f, 0x1f1f1f, 0x1f1f1f]
    refs       = [0, 1, 2, 3, 3]    
    
    time       = 0   


    def __init__(self):
                   
        #create background and checkerboard
        for i in xrange(512):
            s = 64 if (i<256) else int(math.pow((i-256) * 0.00390625, self.power) * (self.power + 2) * self.specular * 0.15915494309189534 * SIZE + 64)
            if s > 255: s = 255
            self.smap[i] = 0x10101 * s
            s = (255-i) if (i<256) else (i-256)
            self.fcol[i] = 0x10101 * (s - (s>>3) + 31)
            self.fcol[i+512] = 0x10101 * ((s>>2) - (s>>5) + 31)
        
        #create spheres and materials
        self.spheres.append(Sphere(100, 40, 60, 2, 0.3, 1.0, 60, Material(0x8080ff, self.ambient, self.diffusion)))
        self.spheres.append(Sphere(  0, 50, 30, 1, 0.8, 0.8, 50, Material(0x80ff80, self.ambient, self.diffusion)))
        self.spheres.append(Sphere( 50, 60, 20, 3, 0.6, 2.0, 40, Material(0xff8080, self.ambient, self.diffusion)))
        self.spheres.append(Sphere(-50, 70, 50, 4, 0.4, 1.4, 30, Material(0xc0c080, self.ambient, self.diffusion)))
        self.spheres.append(Sphere(-90, 30, 60, 5, 0.2, 1.5, 70, Material(0xc080c0, self.ambient, self.diffusion)))
        self.spheres.append(Sphere( 70, 80, 40, 1, 0.7, 1.2, 20, Material(0x80c0c0, self.ambient, self.diffusion)))